;; $Id: sdp_browser.lsp 112 2006-02-23 15:51:14Z pjahn $
;;Browser customizations for Techsoft Solid Power
;;for Windows 2000/XP Professional
;;Guenter Schaumberger 22.02.2006
;;Techsoft Datenverarbeitung Ges.m.b.H.

(in-package :custom)
(use-package :oli)

;;------------------------------------------------------------------------
(defun browser-display-solidpower-part-fnc (node)
 (let ((sel-item (oli::sd-pathname-to-obj (oli::BrowserNode-objPath node)))
       vals ret-val
      )

  (setf ret_val "n/a")
  (when sel-item
   (progn
     (setq vals (sd-inq-item-attribute sel-item "TS-CATALOG-GRUPPE" :values 
        :attachment :contents))
     (when vals
      (setf ret_val (first (last (sd-string-split (second vals) "/"))))
     )  
   )
  )

  ret_val
 )
)

;;------------------------------------------------------------------------
(defun browser-display-solidpower-material-fnc (node)
 (let ((sel-item (oli::sd-pathname-to-obj (oli::BrowserNode-objPath node)))
       vals ret-val
      )

  (setf ret_val "")
  (when (and sel-item
             (sd-logical-table-p "ts-spower-modultabelle")
             (equal (sd-read-logical-table-cell "ts-spower-modultabelle"
                       :column :status :pList `(:modulename "MATERIAL")) 1)
        )
   (progn
     (setq ret_val (custom::ts-werkstoff-inquire-func sel-item)) 
   )
  )

  ret_val
 )
)

;;------------------------------------------------------------------------
(defun browser-display-solidpower-is-part-fnc (node)
 (let ((sel-item (oli::sd-pathname-to-obj (oli::BrowserNode-objPath node)))
       ret-val
      )

  (if (and sel-item (sd-inq-part-p sel-item))
   (setf ret_val "Yes")
   (setf ret_val "No")
  )

  ret_val
 )
)

;;------------------------------------------------------------------------
(defun browser-applicable-solidpower-part-fnc (node)
 (let ((sel-item (oli::sd-pathname-to-obj (oli::BrowserNode-objPath node))))
   (when sel-item
      (or (sd-inq-part-p sel-item) (sd-inq-assembly-p sel-item)) 
   )
 )
)

;;------------------------------------------------------------------------
(defun browser-applicable-solidpower-material-fnc (node)
 (let ((sel-item (oli::sd-pathname-to-obj (oli::BrowserNode-objPath node))))
   (when sel-item
      (or (sd-inq-part-p sel-item) (sd-inq-assembly-p sel-item)) 
   )
 )
)

;;------------------------------------------------------------------------
(defun browser-applicable-solidpower-is-part-fnc (node)
 (let ((sel-item (oli::sd-pathname-to-obj (oli::BrowserNode-objPath node))))
   (when sel-item
      (sd-inq-part-p sel-item) 
   )
   t
 )
)


(oli:sd-create-column-definition 
:solidpower-part
:title "SolidPower Teil"
:display-fnc 'browser-display-solidpower-part-fnc
:applicable-fnc 'browser-applicable-solidpower-part-fnc
:edit-fnc nil ;; not editable
)

(oli:sd-create-column-definition 
:solidpower-material
:title "SolidPower Material"
:display-fnc 'browser-display-solidpower-material-fnc
:applicable-fnc 'browser-applicable-solidpower-material-fnc
:edit-fnc nil ;; not editable
)


(oli:sd-create-column-definition 
:solidpower-part
:title "SolidPower Teil"
:display-fnc 'browser-display-solidpower-part-fnc
:applicable-fnc 'browser-applicable-solidpower-part-fnc
:edit-fnc nil ;; not editable
)

(oli:sd-create-column-definition 
:is-part
:title "Ist Teil"
:display-fnc 'browser-display-solidpower-is-part-fnc
:applicable-fnc 'browser-applicable-solidpower-is-part-fnc
:edit-fnc nil ;; not editable
)


(oli:sd-create-browser-view "SolidPower"
:title "SolidPower Normteile"
:tree-config '( :instance-name "[" :solidpower-part "]")
:detail-config '(:solidpower-part :solidpower-material)
)

(oli::sd-create-browser-filter "parcel-gbrowser"
:name "SolidPower-Normteil"
:title "Kein SolidPower Normteil"
:case-sensitive nil
:match :all
:criteria
 '((:column :solidpower-part :operation :equals :value "n/a")
  )
)

(oli::sd-create-browser-filter "parcel-gbrowser"
:name "SolidPower-Material"
:title "Keinen SolidPower Werkstoff"
:case-sensitive nil
:match :all
:criteria
 '(
   (:column :is-part :operation :equals :value "Yes")
   (:column :solidpower-material :operation :equals :value "")
  )
)
